'''
Created on Jan 31, 2010

@author: richard
'''

def move_up(ant, maze):
    (x, y) = ant.current
    while not maze.is_wall(x, y + 1):
        y += 1
        ant.pass_through(x, y)
        if ant.complete: return

def move_down(ant, maze):
    (x, y) = ant.current
    while not maze.is_wall(x, y - 1):
        y -= 1
        ant.pass_through(x, y)
        if ant.complete: return
    
def move_left(ant, maze):
    (x, y) = ant.current
    while not maze.is_wall(x - 1, y):
        x -= 1
        ant.pass_through(x, y)
        if ant.complete: return

def move_right(ant, maze):
    (x, y) = ant.current
    while not maze.is_wall(x + 1, y):
        x += 1
        ant.pass_through(x, y)
        if ant.complete: return

def move_one_up(ant, maze):
    (x, y) = ant.current
    if not maze.is_wall(x, y + 1):
        y += 1
        ant.pass_through(x, y)
        if ant.complete: return

def move_one_down(ant, maze):
    (x, y) = ant.current
    if not maze.is_wall(x, y - 1):
        y -= 1
        ant.pass_through(x, y)
        if ant.complete: return
    
def move_one_left(ant, maze):
    (x, y) = ant.current
    if not maze.is_wall(x - 1, y):
        x -= 1
        ant.pass_through(x, y)
        if ant.complete: return

def move_one_right(ant, maze):
    (x, y) = ant.current
    if not maze.is_wall(x + 1, y):
        x += 1
        ant.pass_through(x, y)
        if ant.complete: return

def move_right_until_vertical(ant, maze):
    (x,y) = ant.current
    while not maze.is_wall(x + 1, y):
        x += 1
        ant.pass_through(x, y)
        if ant.complete: return
        if not maze.is_wall(x, y + 1) or not maze.is_wall(x, y - 1):
            break

def move_left_until_vertical(ant, maze):
    (x,y) = ant.current
    while not maze.is_wall(x - 1, y):
        x -= 1
        ant.pass_through(x, y)
        if ant.complete: return
        if not maze.is_wall(x, y + 1) or not maze.is_wall(x, y - 1):
            break

def move_up_until_horizontal(ant, maze):
    (x,y) = ant.current
    while not maze.is_wall(x, y + 1):
        y += 1
        ant.pass_through(x, y)
        if ant.complete: return
        if not maze.is_wall(x + 1, y) or not maze.is_wall(x - 1, y):
            break

def move_down_until_horizontal(ant, maze):
    (x,y) = ant.current
    while not maze.is_wall(x, y - 1):
        y -= 1
        ant.pass_through(x, y)
        if ant.complete: return
        if not maze.is_wall(x + 1, y) or not maze.is_wall(x - 1, y):
            break

def move_away_vertical(ant, maze):
    (x, y) = ant.current
    north_wall = maze.is_wall(x, y + 1)
    south_wall = maze.is_wall(x, y - 1)
    if north_wall and not south_wall:
        while not maze.is_wall(x, y - 1):
            y -= 1
            ant.pass_through(x, y)
            if ant.complete: return
    elif not north_wall and south_wall:
        while not maze.is_wall(x, y + 1):
            y += 1
            ant.pass_through(x, y)
            if ant.complete: return

def move_one_away_vertical(ant, maze):
    (x, y) = ant.current
    north_wall = maze.is_wall(x, y + 1)
    south_wall = maze.is_wall(x, y - 1)
    if north_wall and not south_wall:
            y -= 1
            ant.pass_through(x, y)
            if ant.complete: return
    elif not north_wall and south_wall:
            y += 1
            ant.pass_through(x, y)
            if ant.complete: return

def move_away_horizontal(ant, maze):
    (x, y) = ant.current
    east_wall = maze.is_wall(x + 1, y)
    west_wall = maze.is_wall(x - 1, y)
    if east_wall and not west_wall:
        while not maze.is_wall(x - 1, y):
            x -= 1
            ant.pass_through(x, y)
            if ant.complete: return
    elif not east_wall and west_wall:
        while not maze.is_wall(x + 1, y):
            x += 1
            ant.pass_through(x, y)
            if ant.complete: return

def move_one_away_horizontal(ant, maze):
    (x, y) = ant.current
    east_wall = maze.is_wall(x + 1, y)
    west_wall = maze.is_wall(x - 1, y)
    if east_wall and not west_wall:
            x -= 1
            ant.pass_through(x, y)
            if ant.complete: return
    elif not east_wall and west_wall:
            x += 1
            ant.pass_through(x, y)
            if ant.complete: return

"""
def follow_right(ant, maze):
    (x, y) = ant.current
    north_wall = maze.is_wall(x, y + 1)
    south_wall = maze.is_wall(x, y - 1)
    if north_wall and not south_wall:
        while maze.is_wall(x, y + 1) and not maze.is_wall(x + 1, y):
            x += 1
            ant.pass_through(x, y)
            if ant.complete: return
    elif not north_wall and  south_wall:
        while maze.is_wall(x, y - 1) and not maze.is_wall(x + 1, y):
            x += 1
            ant.pass_through(x, y)
            if ant.complete: return
    elif north_wall and south_wall:
        while maze.is_wall(x, y + 1) and maze.is_wall(x, y - 1) and not maze.is_wall(x + 1, y):
            x += 1
            ant.pass_through(x, y)
            if ant.complete: return
"""