'''
Created on Jan 31, 2010

@author: richard
'''

from math import sqrt

class Fitness(object):
    def score(self, ant, maze):
        pass

class FinishedFitness(Fitness):
    
    # the shorter the path, the higher the mark
    def score(self, ant, maze):
        if len(ant.path) == 0:
            return 0.0
        v = 1.0 / float(len(ant.path))
        return v

class UnfinishedFitness(Fitness):
    
    # the closer as the crow flies that the ant gets to the
    # end, the higher the mark
    def score(self, ant, maze):
        closest = self.find_closest_point(ant, maze)
        closeness = 0
        if closest is not None:
            closest += 1 # in case it is zero
            closeness = (1.0 / float(closest))
        return closeness
    
    def find_closest_point(self, ant, maze):
        closest = None
        (ex, ey) = maze.exit
        for (x, y) in ant.path:
            dx = x - ex
            dy = y - ey
            d = sqrt(dx*dx + dy*dy)
            if closest is None or d < closest:
                closest = d
        return closest
